

<< Graphics`Graphics`
<< Graphics`MultipleListPlot`
<< Statistics`ContinuousDistributions`
PicturesPath = 
"/home/vitaly/research/immunology/CFSE/recruitment/data/toolbox/"
data = Import[PicturesPath <> "IL2_50", "Table"]
dataset = Map[Delete[#, {1}] &, data]
timedata = Transpose[data][[1]]

n0 = Dimensions[dataset][[2]]
t0 = Dimensions[dataset][[1]]

nmax = 6

alldata = 
  Flatten[Table[{timedata[[i]], j, 
        If[j == nmax, Sum[dataset[[i, j + k]], {k, 1, n0 - nmax}], 
          dataset[[i, j + 1]]]}, {i, 1, t0}, {j, 0, nmax}], 1]

Clear[i]
For[i = 1, i <= Length[timedata],
  TempFig[i] =
    MultipleListPlot[
      Delete[Transpose[
          Take[Transpose[
              Cases[alldata, x_?(#[[1]] == timedata[[i]] &)]], -2]], 1],
      SymbolShape -> {MakeSymbol[{PointSize[0.025], Point[{0, 0}]}]},
      SymbolStyle -> Hue[(i - 1)/Length[timedata]],
      PlotJoined -> True,
      PlotStyle -> {{Thickness[0.006], Hue[(i - 1)/Length[timedata]]}},
      DisplayFunction -> Identity];
  i++]
Clear[i];

Show[Table[TempFig[i], {i, 1, Length[timedata]}],
    TextStyle -> {FontSize -> 18},
    Frame -> {True, True, False, False},
    Axes -> False,
    PlotRange -> All,
    FrameLabel -> {"division number", "cell number"},
    DisplayFunction -> $DisplayFunction,
    AspectRatio -> 1/GoldenRatio,
    ImageSize -> {450, 270}
    ];

Clear[i]
For[i = 1, i <= nmax,
  TempFig[i] =
    MultipleListPlot[
      Transpose[
        Take[Transpose[Cases[alldata, x_?(#[[2]] == i &)]], {1, 3, 2}]],
      SymbolShape -> {MakeSymbol[{PointSize[0.025], Point[{0, 0}]}]},
      SymbolStyle -> Hue[i/Length[timedata]],
      PlotJoined -> True,
      PlotStyle -> {{Thickness[0.006], Hue[i/Length[timedata]]}},
      DisplayFunction -> Identity];
  i++]
Clear[i];

Show[Table[TempFig[i], {i, 1, nmax}],
    TextStyle -> {FontSize -> 18},
    Frame -> {True, True, False, False},
    Axes -> False,
    PlotRange -> All,
    FrameLabel -> {"time", "cell number"},
    DisplayFunction -> $DisplayFunction,
    AspectRatio -> 1/GoldenRatio,
    ImageSize -> {450, 270}
    ];

datasetT = DeleteCases[alldata, x_?(#[[2]] == 0 &)]

Clear[beta, DB, delta, d, alpha, n, t, ssr, residuals, plotting, eps];

beta[t_, m_, s_, h_] := 
    h*If[t < 0.0, 0, 1/Sqrt[2*Pi]/(s*t)*Exp[-(Log[t/m])^2/(2*s^2)]];

(* beta[t_, m_, s_, c_] := 
      c*If[t < 0.0, 0, 
          If[m == s, m/s^2*Exp[-m/s^2*t], 
            m/s^2*(m/s^2*t)^(m^2/s^2 - 1)/(m^2/s^2 - 1)!*Exp[-m/s^2*t]]]; *)
(* beta modelled by a gammma distribution is commented out *)

DB[d_?NumericQ, alpha_?NumericQ, n_?NumericQ] := 
    If[alpha*n < alpha - d, 0, d + alpha*(n - 1)]; (* 
  making sure that death rate is never negative *)

ssr[m_?NumericQ, s_?NumericQ, c_?NumericQ, d_?NumericQ, delta_?NumericQ, 
      tau_?NumericQ, alpha_?NumericQ] := 
    Module[{B, sol, BB, X, result}, sol = NDSolve[Flatten[Table[
              
              If[n == 1, {B[1]'[t] == 
                    beta[t - tau, m, s, c] - 
                      beta[t - delta - tau, m, s, c]*
                        Exp[-DB[d, alpha, 1]*delta] - DB[d, alpha, 1]*B[1][t],
                   B[1][0] == 0},
                {B[n]'[t] == 
                    2^(n - 1)*Exp[-Sum[delta*DB[d, alpha, i], {i, 1, n - 1}]]*
                        beta[t - (n - 1)*delta - tau, m, s, c] - 
                      2^(n - 1)*Exp[-Sum[delta*DB[d, alpha, i], {i, 1, n}]]*
                        beta[t - n*delta - tau, m, s, c] - 
                      DB[d, alpha, n]*B[n][t], B[n][0] == 0}
                ], {n, 1, nmax + 3}]],
          Table[B[n][t], {n, 1, nmax + 3}],
          {t, 0, Max[timedata]},
          AccuracyGoal -> eps,
          PrecisionGoal -> eps,
          MaxSteps -> 10^4,
          Method -> Automatic
          ];
      Do[BB[n][tt_] = (First[B[n][t] /. sol]) /. t -> tt, {n, 1, nmax + 3}];
      X[n_, t_] := If[n == nmax, Sum[BB[i][t], {i, n, nmax + 3}], BB[n][t]];
      result = Map[(X[#[[2]], #[[1]]] - #[[3]]) &, datasetT, {1}];
      Clear[B, BB, X, sol];
      Apply[Plus, result^2]
      ];

residuals[m_?NumericQ, s_?NumericQ, c_?NumericQ, d_?NumericQ, delta_?NumericQ,
       tau_?NumericQ, alpha_?NumericQ] := 
    Module[{B, sol, BB, X, result}, sol = NDSolve[Flatten[Table[
              
              If[n == 1, {B[1]'[t] == 
                    beta[t - tau, m, s, c] - 
                      beta[t - delta - tau, m, s, c]*
                        Exp[-DB[d, alpha, 1]*delta] - DB[d, alpha, 1]*B[1][t],
                   B[1][0] == 0},
                {B[n]'[t] == 
                    2^(n - 1)*Exp[-Sum[delta*DB[d, alpha, i], {i, 1, n - 1}]]*
                        beta[t - (n - 1)*delta - tau, m, s, c] - 
                      2^(n - 1)*Exp[-Sum[delta*DB[d, alpha, i], {i, 1, n}]]*
                        beta[t - n*delta - tau, m, s, c] - 
                      DB[d, alpha, n]*B[n][t], B[n][0] == 0}
                ], {n, 1, nmax + 3}]],
          Table[B[n][t], {n, 1, nmax + 3}],
          {t, 0, Max[timedata]},
          MaxSteps -> 10^4,
          Method -> Automatic
          ];
      Do[BB[n][tt_] = (First[B[n][t] /. sol]) /. t -> tt, {n, 1, nmax + 3}];
      X[n_, t_] := If[n == nmax, Sum[BB[i][t], {i, n, nmax + 3}], BB[n][t]];
      result = Map[(X[#[[2]], #[[1]]] - #[[3]]) &, datasetT, {1}];
      Clear[B, BB, X, sol];
      result
      ];

plotting[m_?NumericQ, s_?NumericQ, c_?NumericQ, d_?NumericQ, delta_?NumericQ, 
      tau_?NumericQ, alpha_?NumericQ, type_?NumericQ] := 
    Module[{B, sol, BB, X, result}, sol = NDSolve[Flatten[Table[
              
              If[n == 1, {B[1]'[t] == 
                    beta[t - tau, m, s, c] - 
                      beta[t - delta - tau, m, s, c]*
                        Exp[-DB[d, alpha, 1]*delta] - DB[d, alpha, 1]*B[1][t],
                   B[1][0] == 0},
                {B[n]'[t] == 
                    2^(n - 1)*Exp[-Sum[delta*DB[d, alpha, i], {i, 1, n - 1}]]*
                        beta[t - (n - 1)*delta - tau, m, s, c] - 
                      2^(n - 1)*Exp[-Sum[delta*DB[d, alpha, i], {i, 1, n}]]*
                        beta[t - n*delta - tau, m, s, c] - 
                      DB[d, alpha, n]*B[n][t], B[n][0] == 0}
                ], {n, 1, nmax + 3}]],
          Table[B[n][t], {n, 1, nmax + 3}],
          {t, 0, Max[timedata]},
          MaxSteps -> 10^4,
          Method -> Automatic
          ];
      Do[BB[n][tt_] = (First[B[n][t] /. sol]) /. t -> tt, {n, 1, nmax + 3}];
      X[n_, t_] := If[n == nmax, Sum[BB[i][t], {i, n, nmax + 3}], BB[n][t]];
      Which[
        type == 1, 
        Table[{t, X[n, t]}, {n, 1, nmax}, {t, 0, Max[timedata], 
            Max[timedata]/100}],
        type == 2, 
        Table[{n, X[n, timedata[[i]]]}, {i, 1, Length[timedata]}, {n, 1, 
            nmax}],
        type == 3, 
        Table[{t, n, X[n, t]}, {n, 1, nmax}, {t, 0, Max[timedata], 
            Max[timedata]/100}]
        ]
      ];

m0 = 137.6539915
s0 = 0.105757538
c0 = 9300.956932
tau0 = -86.2123378
delta0 = 12.3747
alpha0 = 0.0033444
d0 = 0.028817

eps = 5;

ssr[m0, s0, c0, d0, delta0, tau0, alpha0]

tempPlot = plotting[m0, s0, c0, d0, delta0, tau0, alpha0, 1];
For[i = 1, i <= nmax,
  TempFig[i] =
    MultipleListPlot[
      Transpose[
        Take[Transpose[Cases[alldata, x_?(#[[2]] == i &)]], {1, 3, 2}]],
      tempPlot[[i]],
      SymbolShape -> {MakeSymbol[{PointSize[0.025], Point[{0, 0}]}], None},
      SymbolStyle -> Hue[i/n0],
      PlotJoined -> {False, True},
      PlotStyle -> {None, {Thickness[0.006], Hue[i/n0]}},
      DisplayFunction -> Identity
      ];
  i++]
Show[Table[TempFig[i], {i, 1, nmax}],
    TextStyle -> {FontSize -> 18},
    Frame -> {True, True, False, False},
    Axes -> False,
    PlotRange -> {{-0.001, Last[timedata] + 2}, All},
    FrameLabel -> {"time", "cell number"},
    DisplayFunction -> $DisplayFunction,
    AspectRatio -> 1/GoldenRatio,
    ImageSize -> {450, 270}
    ];
Clear[tempPlot];

Plot[beta[t - tau0, m0, s0, c0], {t, 0, Max[timedata]},
    TextStyle -> {FontSize -> 18},
    Frame -> {True, True, False, False},
    Axes -> False,
    FrameLabel -> {"time", "beta"},
    PlotStyle -> {Thickness[0.006], Hue[0]},
    PlotRange -> All,
    AspectRatio -> 1/GoldenRatio,
    ImageSize -> {450, 270}
    ];

Plot[DB[d0, alpha0, n], {n, 1, 6},
    TextStyle -> {FontSize -> 18},
    Frame -> {True, True, False, False},
    Axes -> False,
    FrameLabel -> {"division number", "d"},
    PlotStyle -> {Thickness[0.006], Hue[0.65]},
    PlotRange -> All,
    AspectRatio -> 1/GoldenRatio,
    ImageSize -> {450, 270}
    ];

  solGH = 
    FindMinimum[ssr[10^m, 10^s, c, d, delta, tau, 
        alpha], {m, Log[10, m0], 
        1.01*Log[10, m0]}, {s, Log[10, s0], 
        1.01*Log[10, s0]}, {c, c0, 
        1.01*c0}, {delta, delta0, 
        1.01*delta0}, {d, d0, 
        1.01*d0}, {tau, tau0, 
        1.01*tau0}, {alpha, alpha0, 
        1.01*alpha0}, AccuracyGoal -> 
        eps, PrecisionGoal -> 
        eps, MaxIterations -> 
        10^4, Method -> 
        Automatic]

Print["Sum of squred residuals = ", ScientificForm[solGH[[1]]]];
Print["Mean, SD and C for beta = ", m0 = 10^(m /. solGH[[2]]), " and ", 
    s0 = 10^(s /. solGH[[2]]), " and ", c0 = (c /. solGH[[2]])];
Print["Delay in beta = ", 
    tau0 = If[NumberQ[(tau /. solGH[[2]])], tau /. solGH[[2]], 0]];
Print["Duration of the division delta = ", delta0 = (delta /. solGH[[2]])];
Print["alpha and d for the death rate = ", alpha0 = (alpha /. solGH[[2]]), 
    " and ", d0 = (d /. solGH[[2]])];
Print["Prob cell death for different division numbers = ", 
    Table[1 - Exp[-DB[d0, alpha0, n]*delta0], {n, 1, nmax}]];

residualsGH = residuals[m0, s0, c0, d0, delta0, tau0, alpha0];
datasetFtestGH = DeleteCases[residualsGH, x_?(# == 0 &)];  (* 
  removing 0 residuals from the dataset *)
Print["Number of fitted parameters = ", ParGH = Length[solGH[[2]]]];
Print["Number of data points for F-test = ", 
    PointsGH = Length[datasetFtestGH]];
Print["MNSQ = ", solGH[[1]]/(PointsGH - ParGH)];
Print["AICc = ",
    PointsGH*Log[solGH[[1]]/PointsGH] + 
      2*(ParGH + 1 + (ParGH + 1)*(ParGH + 2)/(PointsGH - ParGH - 2))];

tempPlot = plotting[m0, s0, c0, d0, delta0, tau0, alpha0, 1];
Clear[i];
For[i = 1, i <= nmax,
  TempFig[i] =
    MultipleListPlot[
      Transpose[
        Take[Transpose[Cases[alldata, x_?(#[[2]] == i &)]], {1, 3, 2}]],
      tempPlot[[i]],
      SymbolShape -> {MakeSymbol[{PointSize[0.025], Point[{0, 0}]}], None},
      SymbolStyle -> Hue[i/n0],
      PlotJoined -> {False, True},
      PlotStyle -> {None, {Thickness[0.006], Hue[i/n0]}},
      DisplayFunction -> Identity
      ];
  i++]
Clear[i];

Show[Table[TempFig[i], {i, 1, nmax}],
    TextStyle -> {FontSize -> 18},
    Frame -> {True, True, False, False},
    Axes -> False,
    PlotRange -> {{-0.001, Last[timedata] + 2}, All},
    FrameLabel -> {"time", "cell number"},
    DisplayFunction -> $DisplayFunction,
    AspectRatio -> 1/GoldenRatio,
    ImageSize -> {450, 270}
    ];

Plot[DB[d0, alpha0, n], {n, 0, 7},
    TextStyle -> {FontSize -> 18},
    Frame -> {True, True, False, False},
    Axes -> False,
    FrameLabel -> {"n", "d"},
    PlotStyle -> {Thickness[0.006], Hue[0.65]},
    PlotRange -> All,
    AspectRatio -> 1/GoldenRatio,
    ImageSize -> {450, 270}
    ];

Plot[beta[t - tau0, m0, s0, c0], {t, 0, Max[timedata]},
    TextStyle -> {FontSize -> 18},
    Frame -> {True, True, False, False},
    Axes -> False,
    FrameLabel -> {"time", "beta"},
    PlotStyle -> {Thickness[0.006], Hue[0]},
    PlotRange -> {-0.001, 350.0001},
    AspectRatio -> 1/GoldenRatio,
    ImageSize -> {450, 270}
    ];

(* Save[(PicturesPath <> "GH_lognormal_d_n_6+_results.txt"), solGH]; *)
